﻿<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>
<body>
<!-- データベースコントロール -->

<form name="form" method="post" action="control.php">

<input type="submit" name="init" value="初期化"/>
<input type="submit" name="disp" value="表示"/>
<input type="submit" name="clear" value="消去"/>
<input type="submit" name="delete" value="削除"/>
<br/>
</form>

<?php

require_once( 'DB.php' );

$dsn = "mysql://user@localhost/user";

$db = DB::Connect( $dsn );

if( DB::isError( $db ) ){
	echo "error:".DB::errorMessage( $db )."<br/>";
} else {
	echo "connected"."<br/>";
}

function init_db( $db )
{
	echo "init_db<br/>";

	$sql = "CREATE TABLE message ( 
	             id INT NOT NULL AUTO_INCREMENT,
	             message CHAR(255) NOT NULL,
	             addr CHAR(64) NOT NULL,
				 flag TINYINT UNSIGNED,
				 ts TIMESTAMP,
	             PRIMARY KEY (id)
			)";
	$res = $db->query( $sql );

	if( $res == DB_OK ){
		echo "OK<br/>";
	} else {
		echo "error: ".DB::errorMessage( $res )."<br/>";
	}
}

function delete_db( $db )
{
	echo "delete_db<br/>";

	$sql = "DROP TABLE IF EXISTS message";

	$res = $db->query( $sql );

	if( $res == DB_OK ){
		echo "OK<br/>";
	} else {
		echo "error: ".DB::errorMessage( $res )."<br/>";
	}
}

function disp_db( $db )
{
	$sql = "SELECT * FROM message WHERE flag = 0 ORDER BY ID DESC LIMIT 100";

	$res = $db->query( $sql );

	echo( '<table cellpadding="0" cellspacing="0">' );

	while( $row = $res->fetchRow( DB_FETCHMODE_ASSOC ) ){
		printf( "<tr><td>&nbsp;%08d&nbsp;</td>
					<td>&nbsp;%s&nbsp;</td><td>&nbsp;%s&nbsp;</td>
					<td>&nbsp;%s&nbsp;</td></tr>\n"
				, $row[ "id" ], $row[ "ts" ]
				, $row[ "addr" ], $row[ "message" ] );
	}	
	echo( "</table>\n" );
}

if( $_POST[ "init" ] != "" ){
	init_db( $db );
} else if( $_POST[ "disp" ] != "" ){
	disp_db( $db );
} else if( $_POST[ "clear" ] != "" ){
	delete_db( $db );
	init_db( $db );
} else if( $_POST[ "delete" ] != "" ){
	delete_db( $db );
}

$db->disconnect();

?>

</body>
</html>
